summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorDaniel Kahn Gillmor <dkg@fifthhorseman.net>2008-10-25 17:39:01 -0400
committerDaniel Kahn Gillmor <dkg@fifthhorseman.net>2008-10-25 17:39:01 -0400
commit6037a421c142502108ce9525c62cd0db4714ecdb (patch)
treef5b4dd7565e86d9686151acaf38ae6e51c519153 /tests
parent55bc90d41588be450c7ab28146683a3017d7ddb3 (diff)
parentfa4afa22523331e9d0325bdbb5b6f92115686bce (diff)
Merge commit 'jrollins/master'
Diffstat (limited to 'tests')
-rwxr-xr-xtests/basic40
-rw-r--r--tests/home/admin/.gnupg/gpg.conf2
-rw-r--r--tests/home/admin/.gnupg/pubring.gpgbin421 -> 4331 bytes
-rw-r--r--tests/home/admin/.gnupg/trustdb.gpgbin1280 -> 1760 bytes
-rw-r--r--tests/home/testuser/.gnupg/gpg.conf3
5 files changed, 29 insertions, 16 deletions
diff --git a/tests/basic b/tests/basic
index fc7dfba..81f3b91 100755
--- a/tests/basic
+++ b/tests/basic
@@ -12,6 +12,9 @@
# NOTE: these tests have *not* themselves been tested yet
# (2008-09-13). Please exercise with caution!
+# fail on fail
+set -e
+
# these tests assume a commonly-trusted "Admin's key", a fake key
# permanently stored in ./home/admin/.gnupg:
gpgadmin() {
@@ -20,6 +23,9 @@ gpgadmin() {
# cleanup:
cleanup() {
+
+ read -p "press enter to cleanup and remove tmp:"
+
# FIXME: stop the sshd process
echo
@@ -63,16 +69,21 @@ export SOCKET="$TEMPDIR"/ssh-socket
### SERVER TESTS
-# create the temp gnupghome directories
+# setup monkeysphere temp gnupghome directories
mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/gnupg-host
mkdir -p -m 700 "$MONKEYSPHERE_SYSDATADIR"/gnupg-authentication
-
-# add the quick-random option to the gpg host config
-echo "quick-random" >> "$MONKEYSPHERE_SYSCONFIGDIR"/gnupg-host/gpg.conf
+cat <<EOF > "$MONKEYSPHERE_SYSDATADIR"/gnupg-authentication/gpg.conf
+primary-keyring ${MONKEYSPHERE_SYSDATADIR}/gnupg-authentication/pubring.gpg
+keyring ${MONKEYSPHERE_SYSDATADIR}/gnupg-host/pubring.gpg
+EOF
# create a new host key
echo "### generating server key..."
+# add gpg.conf with quick-random
+echo "quick-random" >> "$MONKEYSPHERE_SYSCONFIGDIR"/gnupg-host/gpg.conf
echo | monkeysphere-server gen-key --length 1024 --expire 0 testhost
+# remove the gpg.conf
+rm "$MONKEYSPHERE_SYSCONFIGDIR"/gnupg-host/gpg.conf
HOSTKEYID=$( monkeysphere-server show-key | tail -n1 | cut -f3 -d\ )
@@ -80,7 +91,7 @@ HOSTKEYID=$( monkeysphere-server show-key | tail -n1 | cut -f3 -d\ )
# (this would normally be done via keyservers)
echo "### certifying server key..."
monkeysphere-server gpg-authentication-cmd "--armor --export $HOSTKEYID" | gpgadmin --import
-gpgadmin --sign-key "$HOSTKEYID"
+echo y | gpgadmin --command-fd 0 --sign-key "$HOSTKEYID"
# FIXME: how can we test publish-key without flooding junk into the
# keyservers?
@@ -89,7 +100,7 @@ gpgadmin --sign-key "$HOSTKEYID"
# host
echo "### adding admin as certifier..."
-monkeysphere-server add-identity-certifier "$TESTDIR"/home/admin/.gnupg/pubkey.gpg
+echo y | monkeysphere-server add-identity-certifier "$TESTDIR"/home/admin/.gnupg/pubkey.gpg
# initialize base sshd_config
cp etc/ssh/sshd_config "$SSHD_CONFIG"
@@ -101,12 +112,13 @@ EOF
# launch test sshd with the new host key.
echo "### starting sshd..."
-socat EXEC:'/usr/sbin/sshd -f '"$SSHD_CONFIG"' -i -d -d -d -D -e' "UNIX-LISTEN:${SOCKET}" &
+socat EXEC:"/usr/sbin/sshd -f ${SSHD_CONFIG} -i -d -d -d -D -e" "UNIX-LISTEN:${SOCKET}" 2> "$TEMPDIR"/sshd.log &
### TESTUSER TESTS
# copy testuser home directory into temp dir
+echo "### seting up testuser home..."
cp -r "$TESTDIR"/home/testuser "$TEMPDIR"/
# generate an auth subkey for the test user
@@ -115,19 +127,19 @@ MONKEYSPHERE_GNUPGHOME="$TEMPDIR"/testuser/.gnupg \
monkeysphere gen-subkey --expire 0
# add server key to testuser keychain
-monkeysphere-server gpg-authentication-cmd "--armor --export $HOSTKEYID" | \
+echo "### export server key to testuser..."
+gpgadmin --armor --export "$HOSTKEYID" | \
GNUPGHOME="$TEMPDIR"/testuser/.gnupg gpg --import
+#GNUPGHOME="$TEMPDIR"/testuser/.gnupg gpg --list-keys
+#read -p "?"
+
# connect to test sshd, using monkeysphere to verify the identity
# before connection.
-echo "### connecting to sshd socket..."
+echo "### testuser connecting to sshd socket..."
PROXY_COMMAND="monkeysphere-ssh-proxycommand --no-connect %h && socat STDIO UNIX:${SOCKET}"
-ssh -oProxyCommand="$PROXY_COMMAND" testhost
+GNUPGHOME="$TEMPDIR"/testuser/.gnupg ssh -oProxyCommand="$PROXY_COMMAND" testhost
# create a new client side key, certify it with the "CA", use it to
# log in.
## FIXME: implement!
-
-
-### FINISH
-read -p "press enter to cleanup tmp:"
diff --git a/tests/home/admin/.gnupg/gpg.conf b/tests/home/admin/.gnupg/gpg.conf
deleted file mode 100644
index 34bf93a..0000000
--- a/tests/home/admin/.gnupg/gpg.conf
+++ /dev/null
@@ -1,2 +0,0 @@
-# command to avoid depleting the system entropy
-quick-random
diff --git a/tests/home/admin/.gnupg/pubring.gpg b/tests/home/admin/.gnupg/pubring.gpg
index ce19633..8e10c4a 100644
--- a/tests/home/admin/.gnupg/pubring.gpg
+++ b/tests/home/admin/.gnupg/pubring.gpg
Binary files differ
diff --git a/tests/home/admin/.gnupg/trustdb.gpg b/tests/home/admin/.gnupg/trustdb.gpg
index 77ef133..171a891 100644
--- a/tests/home/admin/.gnupg/trustdb.gpg
+++ b/tests/home/admin/.gnupg/trustdb.gpg
Binary files differ
diff --git a/tests/home/testuser/.gnupg/gpg.conf b/tests/home/testuser/.gnupg/gpg.conf
index 34bf93a..f65c71b 100644
--- a/tests/home/testuser/.gnupg/gpg.conf
+++ b/tests/home/testuser/.gnupg/gpg.conf
@@ -1,2 +1,5 @@
# command to avoid depleting the system entropy
quick-random
+# other options
+verify-options show-uid-validity
+list-options show-uid-validity